<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PaxBag ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PaxBag extends AbstractStructArrayBase
{
    /**
     * The PaxBag
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PaxBag[]
     */
    public $PaxBag;
    /**
     * Constructor method for ArrayOfJP_PaxBag
     * @uses ArrayOfJP_PaxBag::setPaxBag()
     * @param \StructType\JP_PaxBag[] $paxBag
     */
    public function __construct(array $paxBag = array())
    {
        $this
            ->setPaxBag($paxBag);
    }
    /**
     * Get PaxBag value
     * @return \StructType\JP_PaxBag[]|null
     */
    public function getPaxBag()
    {
        return $this->PaxBag;
    }
    /**
     * This method is responsible for validating the values passed to the setPaxBag method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaxBag method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaxBagForArrayConstraintsFromSetPaxBag(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PaxBagPaxBagItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PaxBagPaxBagItem instanceof \StructType\JP_PaxBag) {
                $invalidValues[] = is_object($arrayOfJP_PaxBagPaxBagItem) ? get_class($arrayOfJP_PaxBagPaxBagItem) : sprintf('%s(%s)', gettype($arrayOfJP_PaxBagPaxBagItem), var_export($arrayOfJP_PaxBagPaxBagItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaxBag property can only contain items of type \StructType\JP_PaxBag, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaxBag value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PaxBag[] $paxBag
     * @return \ArrayType\ArrayOfJP_PaxBag
     */
    public function setPaxBag(array $paxBag = array())
    {
        // validation for constraint: array
        if ('' !== ($paxBagArrayErrorMessage = self::validatePaxBagForArrayConstraintsFromSetPaxBag($paxBag))) {
            throw new \InvalidArgumentException($paxBagArrayErrorMessage, __LINE__);
        }
        $this->PaxBag = $paxBag;
        return $this;
    }
    /**
     * Add item to PaxBag value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PaxBag $item
     * @return \ArrayType\ArrayOfJP_PaxBag
     */
    public function addToPaxBag(\StructType\JP_PaxBag $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PaxBag) {
            throw new \InvalidArgumentException(sprintf('The PaxBag property can only contain items of type \StructType\JP_PaxBag, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaxBag[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PaxBag|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PaxBag|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PaxBag|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PaxBag|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PaxBag|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaxBag
     */
    public function getAttributeName()
    {
        return 'PaxBag';
    }
}
